VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   0  'None
   Caption         =   "Change Display Settings"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4545
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   ShowInTaskbar   =   0   'False
   Top             =   1170
   Width           =   6810
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  DISPLAY.FRM                                                               *
'                                                                            *
'  This program resizes the desktop to 800x600 using the fg_modeset()        *
'  function.                                                                 *
'                                                                            *
'*****************************************************************************

Const vbWidth = 800
Const vbHeight = 600

Dim hPal As Long
Dim hvb As Long

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
   If KeyCode = vbKeyEscape Or KeyCode = vbKeyF12 Then Unload Me
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)
   Show 0

   If fg_modetest(vbWidth, vbHeight, fg_colors()) <> 0 Then
      Call MsgBox("Cannot set 800x600 desktop", vbOKOnly Or vbCritical, "Error")
      Unload Me
      Exit Sub
   End If
   Call fg_modeset(vbWidth, vbHeight, fg_colors(), 1)
   WindowState = 2 ' maximize window to 800x600

   Call fg_vbinit
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call fg_setcolor(19)
   Call fg_fillpage
End Sub

Private Sub Form_Paint()
   Call fg_vbpaste(0, vbWidth - 1, 0, vbHeight - 1, 0, vbHeight - 1)
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
   Call fg_modeset(0, 0, 0, 0)
End Sub
