/****************************************************************************\
*                                                                            *
*  SWCHARS.CPP                                                               *
*  SWCHARSU.CPP                                                              *
*                                                                            *
*  This program displays all characters in the Fastgraph for Windows primary *
*  and alternate software fonts.                                             *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "SWCharsU.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
      WIDTH(640),
      HEIGHT(480)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb);
   fg_vbcolors();

   fg_initw();
   fg_setworld(0.0,6.39,0.0,4.79);
   fg_setsizew(0.2);

   fg_setcolor(25);
   fg_fillpage();
   fg_setcolor(19);
   fg_movew(3.2,4.2);
   fg_swchar("Software characters - font 1",28,0);
   fg_setcolor(10);
   fg_movew(0.5,3.9);
   fg_swchar("ABCDEFGHIJKLMNOPQRSTUVWXYZ",26,-1);
   fg_movew(0.5,3.6);
   fg_swchar("abcdefghijklmnopqrstuvwxyz",26,-1);
   fg_movew(0.5,3.3);
   fg_swchar("0123456789",10,-1);
   fg_movew(0.5,3.0);
   fg_swchar("!\"#$%&'()*+,-./:;<=>?[]^`{|}~",29,-1);

   fg_setcolor(19);
   fg_movew(3.2,2.5);
   fg_swchar("Software characters - font 2",28,0);
   fg_setcolor(10);
   fg_movew(0.5,2.2);
   fg_swchar("\\ABCDEFGHIJKLMNOPRSTUWXYZ",25,-1);
   fg_movew(0.5,1.9);
   fg_swchar("\\abcdefghijklmnoprstuwxyz",25,-1);
   fg_movew(0.5,1.3);
   fg_swchar("\\012345678#$%&()*+/<=>?[]{}",27,-1);

   fg_setratio(1.2);
   fg_movew(0.5,0.6);
   fg_swchar("cos\\^2\\h\\+sin\\^2\\h\\=1",21,-1);

   fg_movew(5.9,0.6);
   fg_swchar("H\\v2O U\\v2\\v3\\v2",16,1);

   fg_setratio(1.0);
   fg_movew(3.2,0.2);
   fg_swchar("One _word_ is underlined.",25,0);

   fg_setcolor(19);
   fg_movew(0.0,2.8);
   fg_draww(6.39,2.8);
   fg_movew(0.0,0.9);
   fg_draww(6.39,0.9);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbpaste(0,WIDTH-1,0,HEIGHT-1,xdest,ydest);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   xdest = (ClientWidth-WIDTH)/2;
   ydest = (ClientHeight-HEIGHT)/2;
   if (xdest < 0) xdest = 0;
   if (ydest < 0) ydest = 0;
   ydest = (ClientHeight-1)-ydest;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
