VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   Caption         =   "Printing Demo"
   ClientHeight    =   4140
   ClientLeft      =   1155
   ClientTop       =   1800
   ClientWidth     =   6675
   Height          =   4830
   Left            =   1095
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6675
   Top             =   1170
   Width           =   6795
   Begin VB.Menu mnuPrint
      Caption         =   "&Print"
   End
   Begin VB.Menu mnuQuit
      Caption         =   "&Quit"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  PRDEMO.FRM                                                                *
'                                                                            *
'  This program shows how to print the contents of a virtual buffer.  It     *
'  first loads a 640x480 BMP file into a virtual buffer and displays it.     *
'  When the user clicks the Print selection on the top-level menu, a 6-inch  *
'  by 4-inch copy of the BMP image is sent to the default printer.           *
'                                                                            *
'*****************************************************************************

Const vbWidth = 640
Const vbHeight = 480

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call fg_showbmp("PORCH.BMP", 0)
End Sub

Private Sub Form_Paint()
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub

Private Sub mnuPrint_Click()
   If fg_printer(10) = 0 Then
      Call fg_vbprint(0, vbWidth - 1, 0, vbHeight - 1, 0, 600, 0, 400, 2)
      Call fg_printer(1)   ' NEWFRAME
      Call fg_printer(11)  ' ENDDOC
   Else
      Call MsgBox("Printer setup failed", vbCritical, "Error")
   End If
End Sub

Private Sub mnuQuit_Click()
   Unload Me
End Sub
