VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   Caption         =   "Display Strings in Virtual Buffer"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4545
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  STRINGS2.FRM                                                              *
'                                                                            *
'  This program shows how to display strings in a virtual buffer.            *
'                                                                            *
'*****************************************************************************

Const vbWidth = 320
Const vbHeight = 240

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call fg_setcolor(24)
   Call fg_fillpage
   Call fg_setcolor(19)
   Call fg_fontdc(fg_getdc())

   ' upper vertical justification
   Call fg_move(0, 0)
   Call fg_justify(-1, 1)
   Call fg_print("FG/Windows", 10)
   Call fg_move(vbWidth / 2, 0)
   Call fg_justify(0, 1)
   Call fg_print("FG/Windows", 10)
   Call fg_move(vbWidth - 1, 0)
   Call fg_justify(1, 1)
   Call fg_print("FG/Windows", 10)

   ' centered vertical justification
   Call fg_move(0, vbHeight / 2)
   Call fg_justify(-1, 0)
   Call fg_print("FG/Windows", 10)
   Call fg_move(vbWidth / 2, vbHeight / 2)
   Call fg_justify(0, 0)
   Call fg_print("FG/Windows", 10)
   Call fg_move(vbWidth - 1, vbHeight / 2)
   Call fg_justify(1, 0)
   Call fg_print("FG/Windows", 10)

   ' lower vertical justification
   Call fg_move(0, vbHeight - 1)
   Call fg_justify(-1, -1)
   Call fg_print("FG/Windows", 10)
   Call fg_move(vbWidth / 2, vbHeight - 1)
   Call fg_justify(0, -1)
   Call fg_print("FG/Windows", 10)
   Call fg_move(vbWidth - 1, vbHeight - 1)
   Call fg_justify(1, -1)
   Call fg_print("FG/Windows", 10)
End Sub

Private Sub Form_Paint()
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub
